<template>
    <q-page>

      <q-table
      title= "Informations"
      :rows="rows"
      :columns="columns"
      row-key="name"
      @row-click="onRowClick"

    />
      <!-- v-if="selected.id" -->
      <q-form 
      v-if = "selected.id"
      ref = "tawag"
        @submit="updateForm()" class="q-ma-md">

      <h6 class="text-h6 text-left q-ma-none">
          Fillupan mo: </h6> 
        
      <q-input v-model="name" label="Name"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']" />
      <q-input v-model="username" label="Username"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="email" label="Email"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <div>
      <h6 class="text-h6 text-left q-ma-none"> Address: </h6>
      <!-- <span>{{ address }}</span> -->
      <q-input v-model="address.street" label="Street"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="address.suite" label="Suite"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="address.city" label="City"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="address.zipcode" label="zipcode"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="address.geo.lat" label="Latitude"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="address.geo.lng" label="Longitude"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      </div>
      <h6 class="text-h6 text-left q-ma-none"> Other Info: </h6>
      <q-input v-model="phone" label="Cellphone Number"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="website" label="Website"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <h6 class="text-h6 text-left q-ma-none"> Company: </h6>
      <q-input v-model="company.name" label="Company Name"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>
      <q-input v-model="company.catchPhrase" label="Catch Phrase"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>  
      <q-input v-model="company.bs" label="BS"
        class="q-pa-none col-10"
        lazy-rules
        :rules="[(val) => !!val || 'Field is required']"/>   
      
    <q-btn
      :loading = "btnLoadingState"
      style="margin-right: 10px"
      type="updateForm"
      label= "Update"
      color="purple"
    />
        
    <q-btn
		:loading="deleteBtnLoadingState"
        v-if="selected.id" 
	    @click="deleteForm()"
        class="q-ml-md"
        label="Delete"
        color="negative"
      />

    </q-form>
</q-page>

    
  </template>

  <script>
  import { ref, computed } from 'vue';
  import axios from 'axios';
  import { AddUserPage, ListofUsers } from "../composables/Users";
  let rows = ref([]);
  export {rows};
  
  export default {
    setup () {
      // const getUser = () => {
      //   axios
      //     .get("https://jsonplaceholder.typicode.com/users")
      //     .then((response) => {
      //       rows.value = response.data;
      //     });
      // };
      // getUser();

      const id = ref('');
      const name = ref('');
      const username = ref('');
      const email = ref('');
      const address = ref({
        street: '',
        suite: '',
        city: '',
        zipcode:'',
        geo: ref({
          lat: '',
          lng: '',
        })
      });
      const phone = ref('');
      const website = ref('');
      const company = ref({
        name: '',
        catchPhrase: '',
        bs: '',
      });

      const submitted = ref(false);
      const form = computed(() => ({
        id: id.value,
        name: name.value,
        username: username.value,
        email: email.value,
        address: address.value,
        phone: phone.value,
        website: website.value,
        company: company.value,
      }));

      
      const columns = ref([
        {
          name: "id",
          label: "Id",
          align: "left",
          field: "id",
        },
        {
          name: "name",
          label: "Name",
          align: "left",
          field: "name",
          
        },
        {
          name: "username",
          label: "Username",
          align: "left",
          field: "username",
        },
        {
          name: "email",
          label: "Email",
          align: "left",
          field: "email",
        },
        {
          name: "address",
          label: "Address",
          align: "left",
          field: "address",
          format: (value, row) => {
            const { street, suite, city, zipcode, geo } = row.address;
            return `${street} St., ${suite}, ${city} City,  zip:${zipcode}, lat:${geo.lat}, lng:${geo.lng}`;
          },
        },
        {
          name: "phone",
          label: "Phone",
          align: "left",
          field: "phone",
        },
        {
          name: "website",
          label: "Website",
          align: "left",
          field: "website",
        },
        {
          name: "company",
          label: "Company",
          align: "left",
          field: "company",
          format: (value, row) => {
            const { name, catchPhrase, bs } = row.company;
            return `${name}, Catchphrase: ${catchPhrase}, BS: ${bs}`;
          },
        },
      ]);


      let tawag = ref(null);
      let btnLoadingState = ref(false);
      const addForm = () => {
          btnLoadingState.value = true;
          axios
          .post("https://jsonplaceholder.typicode.com/users", 
          AddUserPage.value)
          .then((response) => {
            console.log(response) 
            if (response.status === 201) {
              rows.value.unshift(response.data);
              // console.log(length)
              id.value = rows.value.length +1;
              name.value = '';
              username.value = '';
              email.value = '';
              address.value ={
                street: '',
                suite: '',
                city: '',
                zipcode: '',
                geo: {
                  lat: '',
                  lng: '',
                },
              };
              phone.value = '';
              website.value = '';
              company.value ={
                name: '',
                catchPhrase: '',
                bs:''
              };
          
          }
          btnLoadingState.value = false;
          
        })
        tawag.value.reset();
      }
      let selected = ref({});
      // let selected = ref(null);
      function onRowClick (evt,row) {
        selected.value = row;
        id.value = row.id;
        name.value = row.name;
        username.value = row.username;
        email.value = row.email;
        address.value = row.address;
        phone.value = row.phone;
        website.value = row.website;
        company.value = row.company;

      };
      
      const updateForm = () => {
        btnLoadingState.value = true;
        axios
          .put(
            `https://jsonplaceholder.typicode.com/users/${selected.value.id}`,
            {

              id: id.value,
              name: name.value,
              username: username.value,
              email: email.value,
              address: address.value,
              phone: phone.value,
              website: website.value,
              company: company.value,
            }
          )
          .then((response) => {
            
            if (response.status === 200) {
              let index = rows.value.findIndex(
                (row) => row.id === selected.value.id);

              // rows.value[index].form = response.data.form;
              rows.value[index].name = response.data.name;
              rows.value[index].username = response.data.username;
              rows.value[index].email = response.data.email;
              rows.value[index].address = response.data.address;
              rows.value[index].phone = response.data.phone;
              rows.value[index].website = response.data.website;
              rows.value[index].company = response.data.company;

              name.value = '';
              username.value = '';
              email.value = '';
              address.value ={
                street: '',
                suite: '',
                city: '',
                zipcode: '',
                geo: {
                  lat: '',
                  lng: '',
                },
              };
              phone.value = '';
              website.value = '';
              company.value ={
                name: '',
                catchPhrase: '',
                bs:''
              };
              
              selected.value = {};
              
            }
            btnLoadingState.value = false;
            
          });
          tawag.value.reset();
      };

      let deleteBtnLoadingState = ref(false);
    const deleteForm = () => {
      deleteBtnLoadingState.value = true;
      axios
        .delete(
          `https://jsonplaceholder.typicode.com/todos/${selected.value.id}`
        )
        .then((response) => {
          console.log(response)
          if (response.status === 200) {
            rows.value = rows.value.filter(
              (row) => row.id !== selected.value.id
            );
            name.value = '';
              username.value = '';
              email.value = '';
              address.value ={
                street: '',
                suite: '',
                city: '',
                zipcode: '',
                geo: {
                  lat: '',
                  lng: '',
                },
              };
              phone.value = '';
              website.value = '';
              company.value ={
                name: '',
                catchPhrase: '',
                bs:''
              };
              selected.value = {};
          }
          deleteBtnLoadingState.value = false;
        });
    };

      
              
      return{
        addForm,
        tawag,
        columns,
        rows,
        form,
        submitted,
        username,
        name,
        email,
        address,
        phone,
        website,
        company,
        id,
        btnLoadingState,
        onRowClick,
        updateForm,
        selected,
        deleteForm,
        deleteBtnLoadingState,
        ListofUsers

      }
        
    }
        
    }



  </script>












